pipeline {
    environment {
        IMAGE_NAME = "ic-webapp"
        IMAGE_TAG = "latest"
        LOCAL_TAG = "1.0"
        IP_ANSIBLE = "44.209.244.170"
        IP_ODOO = "184.72.83.140"
        IP_PGADMIN = "54.91.148.132"
        JENKINS_PATH = "jenkins_path"
        USER_SERVER = "ubuntu"
        REPO_ODOO = "https://gitlab.com/CarlinFongang-Labs/projet-odoo/deploy-odoo-postgresql-pgadmin/odoo-postgresql-ansible.git"
        REPO_PGADMIN = "https://gitlab.com/CarlinFongang-Labs/projet-odoo/deploy-odoo-postgresql-pgadmin/pgadmin-webapp-with-ansible.git"
    }
    agent {
        label 'runner_ec2_aws'
    }
    stages {
       stage('gitlab webhook') {
          steps {
             echo 'Notify GitLab'
             updateGitlabCommitStatus name: 'build', state: 'pending'
             updateGitlabCommitStatus name: 'build', state: 'success'
            }
       } 
        stage('Build image') {
            steps {
                script {
                    sh 'which git'
                    sh 'echo "Testing shell execution"'
                    sh 'pwd'
                    sh 'docker build -t $IMAGE_NAME:$LOCAL_TAG .'
                }
            }
        }
        stage('Run contenair') {
            //agent { docker { image 'alpine' } }
            steps {
                script {
                    sh 'docker run -d -p 8080:8080 --name $IMAGE_NAME-test $IMAGE_NAME:$LOCAL_TAG'
                    sh 'sleep 5'
                    sh 'sudo apt install curl -y'
                }
            }
        }
        stage('Test image') {
            agent any
            steps {
                script {
                    sh '''
                        docker ps
                        IP_TEST=$(docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' "$IMAGE_NAME-test")
                        response=$(curl -s -o /dev/null -w "%{http_code}" "http://$IP_TEST:8080")
                        if [ "$response" -eq 200 ]; then
                            echo "La connexion au conteneur est réussie."
                        else
                            echo "Erreur: La connexion au conteneur a échoué avec le code de réponse HTTP $response."
                        fi
                    '''  
                }
            }
        }
        stage('Clean Test') {
            agent any
            steps {
                script {
                    sh '''
                        docker stop ${IMAGE_NAME}-test && docker rm ${IMAGE_NAME}-test
                    '''
                }
            }
        }
        stage('Release Docker image') {
            environment {
                DOCKERHUB_USER = credentials('DHUB_USER')
                DOCKERHUB_TOKEN = credentials('DHUB_TOKEN')        
            }
            agent any
            steps {
                script {                    
                    sh 'docker tag $IMAGE_NAME:$LOCAL_TAG $DOCKERHUB_USER/$IMAGE_NAME:$IMAGE_TAG'
                    sh 'docker tag $IMAGE_NAME:$LOCAL_TAG $DOCKERHUB_USER/$IMAGE_NAME:$GIT_COMMIT'
                    sh 'echo $DOCKERHUB_TOKEN | docker login -u $DOCKERHUB_USER --password-stdin'
                    sh 'docker push $DOCKERHUB_USER/$IMAGE_NAME:$IMAGE_TAG'
                    sh 'docker push $DOCKERHUB_USER/$IMAGE_NAME:$GIT_COMMIT'  
                    sh 'echo "Publication de l image sur DockerHub..." '
                }
            }
        }
        stage('Deploy stack Odoo_Postgres') {
            environment {
                SSH_EC2 = credentials('SSH_EC2')
            }
            steps {
                script { 
                    sh'''
                        export PATH=$PATH:/home/ubuntu/.local/bin
                        rm -rf odoo-stack-deploy
                        git clone $REPO_ODOO ./odoo-stack-deploy
                        cd odoo-stack-deploy

                        ansible-galaxy install -r roles/requirements.yml -f
                        chmod 600 $SSH_EC2

                        ssh -o StrictHostKeyChecking=no -i $SSH_EC2 ${USER_SERVER}@${IP_ODOO} "
                        rm -rf .secrets
                        mkdir .secrets
                        echo "odoo" > .secrets/odoo_pg_pass
                        "
                        
                        ansible-playbook -i hosts.yml odoo-deploy.yml --private-key $SSH_EC2 -vvv  
                    '''
                }
            }
        }
        stage('Deploy stack PGAdmin_IC_WebApp') {
            environment {
                SSH_EC2 = credentials('SSH_EC2')
            }
            steps {
                script { 
                    sh'''
                        export PATH=$PATH:/home/ubuntu/.local/bin
                        rm -rf pgadmin-stack-deploy
                        git clone $REPO_PGADMIN  ./pgadmin-stack-deploy
                        cd pgadmin-stack-deploy
                        ansible-galaxy install -r roles/requirements.yml -f
                        chmod 600 $SSH_EC2

                        ssh -o StrictHostKeyChecking=no -i $SSH_EC2 ${USER_SERVER}@${IP_PGADMIN} "
                        ls
                        "

                        ansible-playbook -i hosts.yml pgadmin-deploy.yml --private-key $SSH_EC2 -vvv
                    '''
                }
            }
        }
    }
}